var innerBridge = {
    default:this,// for typescript
    call: function (method, args, cb) {
        var ret = '';
        if (typeof args == 'function') {
            cb = args;
            args = {};
        }
        var arg={data:args===undefined?null:args}
        if (typeof cb == 'function') {
            var cbName = '_cjDscb' + window._cjDscb++;
            window[cbName] = cb;
            arg['_dscbstub'] = cbName;
        }
        arg = JSON.stringify(arg)

        //if in webview that dsBridge provided, call!
        if(window._cjDsBridge){
           ret=  _cjDsBridge.call(method, arg)
        }
            console.log(ret);
       return  JSON.parse(ret||'{}').data
    },
    register: function (name, fun, asyn) {
        var q = asyn ? window._cjDsaf : window._cjDsf
        if (!window._cjDsInit) {
            window._cjDsInit = true;
            //notify native that js apis register successfully on next event loop
            setTimeout(function () {
                innerBridge.call("_cjDsb.dsinit");
            }, 0)
        }
        if (typeof fun == "object") {
            q._obs[name] = fun;
        } else {
            q[name] = fun
        }
    },
    registerAsyn: function (name, fun) {
        this.register(name, fun, true);
    },
    hasNativeMethod: function (name, type) {
        return this.call("_cjDsb.hasNativeMethod", {name: name, type:type||"all"});
    },
    disableJavascriptDialogBlock: function (disable) {
        this.call("_cjDsb.disableJavascriptDialogBlock", {
            disable: disable !== false
        })
    }
};

!function () {
    if (window._cjDsf) return;
    var ob = {
        _cjDsf: {
            _obs: {}
        },
        _cjDsaf: {
            _obs: {}
        },
        _cjDscb: 0,
        cjDsBridge: innerBridge,
        _cjClose: function () {
            innerBridge.call("_cjDsb.closePage")
        },
        _cjHandleMessageFromNative: function (info) {
            var arg = JSON.parse(info.data);
            var ret = {
                id: info.callbackId,
                complete: true
            }
            var f = this._cjDsf[info.method];
            var af = this._cjDsaf[info.method]
            var callSyn = function (f, ob) {
                ret.data = f.apply(ob, arg)
                innerBridge.call("_cjDsb.returnValue", ret)
            }
            var callAsyn = function (f, ob) {
                arg.push(function (data, complete) {
                    ret.data = data;
                    ret.complete = complete!==false;
                    innerBridge.call("_cjDsb.returnValue", ret)
                })
                f.apply(ob, arg)
            }
            if (f) {
                callSyn(f, this._cjDsf);
            } else if (af) {
                callAsyn(af, this._cjDsaf);
            } else {
                //with namespace
                var name = info.method.split('.');
                if (name.length<2) return;
                var method=name.pop();
                var namespace=name.join('.')
                var obs = this._cjDsf._obs;
                var ob = obs[namespace] || {};
                var m = ob[method];
                if (m && typeof m == "function") {
                    callSyn(m, ob);
                    return;
                }
                obs = this._cjDsaf._obs;
                ob = obs[namespace] || {};
                m = ob[method];
                if (m && typeof m == "function") {
                    callAsyn(m, ob);
                    return;
                }
            }
        }
    }
    for (var attr in ob) {
        window[attr] = ob[attr]
    }
    innerBridge.register("_cjHasJavascriptMethod", function (method, tag) {
         var name = method.split('.')
         if(name.length<2) {
           return !!(_cjDsf[name]||_cjDsaf[name])
         }else{
           // with namespace
           var method=name.pop()
           var namespace=name.join('.')
           var ob=_cjDsf._obs[namespace]||_cjDsaf._obs[namespace]
           return ob&&!!ob[method]
         }
    })
}();
module.exports = innerBridge;